package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.EmpresaAdyenConfigDAO;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaAdyenConfig;
import com.rjconsultores.ventaboletos.service.EmpresaAdyenConfigService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("empresaAdyenConfigService")
public class EmpresaAdyenConfigServiceImpl implements EmpresaAdyenConfigService {

	@Autowired
	private EmpresaAdyenConfigDAO empresaAdyenConfigDAO;

	@Override
	public List<EmpresaAdyenConfig> obtenerTodos() {
		return empresaAdyenConfigDAO.obtenerTodos();
	}

	@Override
	public EmpresaAdyenConfig obtenerID(Integer id) {
		return empresaAdyenConfigDAO.obtenerID(id);
	}

	@Override
	@Transactional
	public EmpresaAdyenConfig suscribir(EmpresaAdyenConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaAdyenConfigDAO.suscribir(entidad);
	}

	@Override
	@Transactional
	public EmpresaAdyenConfig actualizacion(EmpresaAdyenConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);

		return empresaAdyenConfigDAO.actualizacion(entidad);
	}

	@Override
	@Transactional
	public void borrar(EmpresaAdyenConfig entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);

		empresaAdyenConfigDAO.actualizacion(entidad);

	}

	@Override
	public EmpresaAdyenConfig buscarPorEmpresa(Empresa empresa) {
		return empresaAdyenConfigDAO.buscarPorEmpresa(empresa);
	}

}
